<template>
    <q-layout view="hHh lpR fFf">
        <q-page-container v-if="!usersLoading && !confsLoading">
            <q-header elevated>
                <Toolbar :hasBackButton="true" :pageTitle="$t('billing.page_title')" />
            </q-header>

            <q-page class="pl-fullpage">
                <h4 class="q-my-md">
                    {{ $t('billing.page_title') }}
                </h4>

                <div class="costs-head">
                    <div style="flex-grow: 4;">
                        {{ $t('billing.costs_for_month', [$t(`billing.month_${currentMonthNumber}`), currentYear]) }}
                    </div>

                    <div style="flex-grow: 1; text-align: right;">
                        {{ totalCost }}
                    </div>
                </div>

                <q-list>
                    <q-item v-for="(acc, index) in conferencesByAccount || []" :key="index">
                        <AccountBillingCard :account="acc" :windowWidth="windowWidth" />
                    </q-item>
                    <div v-if="usersLoading || confsLoading">
                        {{ $t('loading') }}
                    </div>
                    <div v-else-if="!monthConferences">
                        {{ $t('billing.no_data') }}
                    </div>
                </q-list>

                <div style="width: 100%; margin: 20px 0px 40px 0px;">
                    <q-btn flat color="primary" icon="arrow_back" style="float:left" @click="() => onPrevious()">
                        {{ $t('billing.prev_month') }}
                    </q-btn>

                    <q-btn v-if="canNext" flat color="primary" icon-right="arrow_forward" style="float:right"
                        @click="() => onNext()">
                        {{ $t('billing.next_month') }}
                    </q-btn>
                </div>
            </q-page>
        </q-page-container>
    </q-layout>
</template>
<script>
import { db } from "../../firebase";
import Toolbar from "../../components/Toolbar.vue";
import AccountBillingCard from "../../components/AccountBillingCard.vue"
import moment from 'moment'
import { parseNumber } from "../../utils/phone"

export default {
    data()
    {
        return {
            currentMonthNumber: moment().month(),
            currentYear: moment().year(),
            changes: {},
            monthConferences: [],
            users: {},
            confsLoading: true,
            usersLoading: true,
            windowWidth: window.innerWidth
        };
    },
    mounted()
    {
        this.$nextTick(() =>
        {
            window.addEventListener('resize', this.onResize);
        })
    },
    beforeDestroy()
    {
        window.removeEventListener('resize', this.onResize);
    },
    created()
    {
        this.$rtdbBind("users", db.ref('Users')).then(() => this.usersLoading = false);
    },
    watch: {
        currentMonthNumber: {
            immediate: true,
            handler(currentMonthNumber)
            {
                // load conferences from within the selected month
                this.loading = true;
                const thisMonth = moment(`01/${currentMonthNumber + 1}/${this.currentYear}`, "DD/MM/YYYY");
                const startTime = thisMonth.startOf('month').valueOf();
                const endTime = thisMonth.endOf('month').valueOf();

                this.$rtdbBind("monthConferences",
                    db.ref('Conferences/Complete')
                        .orderByChild('ActualStart')
                        .startAt(startTime).endAt(endTime)).then(() => this.confsLoading = false);
            }
        }
    },
    methods: {
        onResize()
        {
            this.windowWidth = window.innerWidth
        },
        onPrevious()
        {
            if (this.currentMonthNumber == 0)
            {
                this.currentYear--;
                this.currentMonthNumber = 11;
            }
            else
            {
                this.currentMonthNumber--;
            }
        },
        onNext()
        {
            if (this.currentMonthNumber == 11)
            {
                this.currentYear++;
                this.currentMonthNumber = 0;
            }
            else
            {
                this.currentMonthNumber++;
            }
        }
    },
    computed:
    {
        canNext()
        {
            let nextYear = this.currentYear;
            let nextMonth = this.currentMonthNumber + 1;
            if (nextMonth > 11)
            {
                nextYear++;
                nextMonth = 0;
            }

            return moment(`01/${nextMonth + 1}/${nextYear}`, "DD/MM/YYYY").diff(moment()) <= 0;
        },
        totalCost()
        {
            if (!this.users) return "";
            let total = 0;
            let computed = this.conferencesByAccount;
            for (const key in computed)
            {
                total += computed[key].total || 0;
            }

            const formatter = new Intl.NumberFormat('en-GB', {
                style: 'currency',
                currency: 'USD',
            });

            return this.$t('billing.costs_total', [formatter.format(total || 0)]);
        },
        conferencesByAccount() 
        {
            if (!this.users) return {};

            let accs = {};

            this.monthConferences.forEach(conf => 
            {
                let totalTime = 0;
                let totalCost = 0;

                for (const p in conf.Participants)
                {
                    const parsed = parseNumber(p);
                    const mins = conf.Participants[p].TotalCallTime / 1000 / 60;
                    const rate = conf.Costing ? parseFloat(conf.Costing['+' + parsed.countryCallingCode]) : 0;
                    const pCost = rate * (mins ?? 0);

                    totalCost += pCost;
                    totalTime += conf.Participants[p].TotalCallTime;
                    conf.Participants[p].Cost = pCost;
                    conf.Participants[p].Rate = rate;
                }

                conf.total = totalCost;
                conf.totalTime = totalTime / 1000 / 60;

                if (conf.Owner in accs)
                {
                    accs[conf.Owner].conferences.push(conf)
                    accs[conf.Owner].total += totalCost || 0;
                }
                else 
                {
                    accs[conf.Owner] = {
                        'name': this.users[conf.Owner].Name,
                        'email': this.users[conf.Owner].Email,
                        'phone': this.users[conf.Owner].Phone,
                        'total': totalCost || 0,
                        'conferences': [conf]
                    }
                }
            });

            let toRet = Object.values(accs);
            toRet.sort((a, b) => { return b.total - a.total })
            return toRet;
        }
    },
    components: {
        Toolbar,
        AccountBillingCard
    },
};
</script>
<style scoped>
.centred {
    margin: 10px auto;
    width: 180px;
}

.costs-head {
    display: flex;
    margin: 40px 10px 20px 10px;
    font-size: x-large;
    font-weight: bold;
}
</style>
    